Unit List;

Interface

Uses TIdef;

Const
  maxdir = 32;
  maxvar = 96;
  list_delay = 40;
  list_speed = 6;
Type
  dir = Array [0..maxvar] Of pTIvar;
  pdir = ^dir;
  lst = Record
          name : String[12];
          xs,x,y1,y2,len : Byte;
          curdir : Byte;
          ofs : Word;
          sel_nb : Word;
          sel_size : LongInt;
          item : Array [0..maxdir] Of pdir;
        End;
Var
  release : Boolean;

Procedure Disp_item (x,y : Byte; z : pTIvar);
Procedure Disp_list (Var l : lst; selec : Boolean);
Procedure Check_list (Var l : lst; mx,my : Byte);
Function List_up (Var l : lst) : Boolean;
Function List_dn (Var l : lst) : Boolean;
Procedure Enter_dir (Var l : lst; mx,my : Byte);
Function Create_dir (Var l : lst; _name : TIstr) : Boolean;
Procedure New_var (Var l : lst; v : pTIvar; disp : Boolean);
Procedure Selection (Var l : lst);
Procedure Clean_list (Var l : lst);
Procedure Close_list (Var l : lst);

Implementation

Uses Debug,Mouse,Timer,Txt;

Const
  limit : Boolean = True;

Procedure Disp_item (x,y : Byte; z : pTIvar);
Const
  void ='                     ';
Var
  color : String[2];
Begin
  If (z=nil) Then
    Text (x,y,#0#31+void)
  Else
    With z^ Do
    Begin
      If sel Then
        color :=#0#79
      Else
        color :=#0#31;
      Text (x,y,color+void);
      If typ=31 Then
        Text (x,y,UpCase (name))
      Else
        Text (x,y,name);
      Text (x+10,y,TI_type[typ]);
      If (typ<30) Then
        Text (x+15,y,Number (6,size));
      If (typ=31) Then
        Text (x+15,y,Number (6,size-1));
    End;
End;

Procedure Disp_list (Var l : lst; selec : Boolean);
Var
  i,j : Byte;
  a,b,c,_nb : Word;
  s : String[32];
Begin
  With l Do
  Begin
    Hide_mouse;
    a :=ofs;
    j :=y2;
    _nb :=item[0]^[curdir]^.size;
    For i :=y1 To y2 Do
    Begin
      If (a<=_nb) Then
        Disp_item (x,i,item[curdir]^[a])
      Else
        Disp_item (x,i,nil);
      Inc (a);
    End;
    Text (xs,y1,#0#23'');
    For i :=y1+1 To y2-1 Do
      Text (xs,i,#0#23'');
    Text (xs,y2,#0#23'');
    If _nb>0 Then
    Begin
      c :=Word (((y2-y1+1)*(y2-y1-1)) Div _nb);
      If c>(y2-y1-1) Then c :=y2-y1-1;
      If ofs=1 Then b :=y1+1 Else
        b :=y1+2+Word (((y2-y1-2-c)*(ofs-1)) Div (_nb-(y2-y1+1)));
      For a :=b To b+c-1 Do Text (xs,a,'');
    End;
    s :=name+':\';
    If curdir>0 Then
      s :=s+UpCase (item[0]^[curdir]^.name);
    i :=x+(len-Length (s)) Shr 1;
    Text (x,y1-1,#0#126'                ');
    Text (i,y1-1,s);
    sel_nb :=0;
    sel_size :=0;
    For a :=1 To item[0]^[curdir]^.size Do
      If item[curdir]^[a]^.sel Then
        If curdir>0 Then
          Begin
            If (a>1) Then
            Begin
              Inc (sel_nb);
              Inc (sel_size,item[curdir]^[a]^.size);
            End
          End
        Else
          For b :=2 To item[0]^[a]^.size Do
          Begin
            Inc (sel_nb);
            Inc (sel_size,item[a]^[b]^.size);
          End;
    If selec Then Selection (l);
    Show_mouse;
  End;
End;

Procedure Check_list (Var l : lst; mx,my : Byte);
Var
  b : Boolean;
  c,my0 : Byte;
  i,j : Word;
Begin
  With l Do
  Begin
    If (Abs (mx-xs)<=1) Then
    Begin
      If (my>=y1) And (my<=y1+2) Then
        List_up (l);
      If (my>=y2-2) And (my<=y2) Then
        List_dn (l);
    End;
    If (mx>=x) And (mx<x+len) Then
    Begin
      If (my>=y1) And (my<=y2) Then
      Begin
        limit :=True;
        i :=my+ofs-y1;
        If (i<=item[0]^[curdir]^.size) Then
        Begin
          If (limit) And (item[curdir]^[i]^.typ<>30) Then
          Begin
            Hide_mouse;
            b :=item[curdir]^[i]^.sel;
            item[curdir]^[i]^.sel :=Not b;
            Disp_item (x,y1+i-ofs,item[curdir]^[i]);
            If b Then
              If curdir>0 Then
                Begin
                  Dec (sel_nb);
                  Dec (sel_size,item[curdir]^[i]^.size);
                End
              Else
                For j :=2 To item[0]^[i]^.size Do
                  Begin
                    Dec (sel_nb);
                    Dec (sel_size,item[i]^[j]^.size);
                  End
            Else
              If curdir>0 Then
                Begin
                  Inc (sel_nb);
                  Inc (sel_size,item[curdir]^[i]^.size);
                End
              Else
                For j :=2 To item[0]^[i]^.size Do
                  Begin
                    Inc (sel_nb);
                    Inc (sel_size,item[i]^[j]^.size);
                  End;
            Selection (l);
            Show_mouse;
          End;
          If (my>=y1) And (my<=y2) Then
          Begin
            my0 :=my;
            Repeat
              Get_mouse_XY (mx,my);
              c :=Get_mouse_clic;
            Until (c=0) Or (my<>my0) Or (mx<x) Or (mx>=x+len);
            If c=0 Then release :=True;
          End;
        End;
      End;
    End;
  End;
End;

Function List_up (Var l : lst) : Boolean;
Begin
  If (l.ofs>1) Then
    Begin
      Dec (l.ofs);
      Disp_list (l,False);
      List_up :=True;
      If release Then
        Begin
          Delay (list_delay);
          release :=False;
        End
      Else
        Delay (list_speed);
    End
  Else
    List_up :=False;
End;

Function List_dn (Var l : lst) : Boolean;
Var
  _nb : Word;
Begin
  _nb :=l.item[0]^[l.curdir]^.size;
  If (l.ofs+l.y2-l.y1<_nb) Then
    Begin
      Inc (l.ofs);
      Disp_list (l,False);
      List_dn :=True;
      If release Then
        Begin
          Delay (list_delay);
          release :=False;
        End
      Else
        Delay (list_speed);
    End
  Else
    List_dn :=False;
End;

Procedure Enter_dir (Var l : lst; mx,my : Byte);
Var
  i : Word;
Begin
  With l Do
  Begin
    If (mx>=x) And (mx<x+len) Then
      If (my>=y1) And (my<=y2) Then
      Begin
        i :=my+ofs-y1;
        If (i<=item[0]^[curdir]^.size) Then
          If curdir=0 Then
            Begin
              item[0]^[i]^.sel :=Not item[0]^[i]^.sel;
              curdir :=i;
              ofs :=1;
              Disp_list (l,True);
            End
          Else
            If i=1 Then
            Begin
              curdir :=0;
              ofs :=1;
              Disp_list (l,True);
            End;
      End;
  End;
End;

Function Create_dir (Var l : lst; _name : TIstr) : Boolean;
Var
  i,j,max : Word;
Begin
  With l Do
  Begin
    i :=1;
    max :=item[0]^[0]^.size;
    While (i<=max) And (item[0]^[i]^.name<>_name) Do
      Inc (i);
    If i>max Then
      {dir doesn't exist}
      Begin
        {find its alphabetical place}
        i :=1;
        While (i<=max) And (item[0]^[i]^.name<_name) Do
          Inc (i);
        For j :=max DownTo i Do
        Begin
          item[0]^[j+1] :=item[0]^[j]; {dir info}
          item[j+1] :=item[j]; {dir content}
        End;
        New (item[i]); Inc (_malloc,SizeOf (dir));
        New (item[0]^[i]); Inc (_malloc,SizeOf (TIvar));
        With item[0]^[i]^ Do
        Begin
          name :=_name;
          typ :=31;
          size :=1;
          sel :=False;
        End;
        New (item[i]^[1]); Inc (_malloc,SizeOf (TIvar));
        With item[i]^[1]^ Do
        Begin
          name :='..      ';
          typ :=30;
          size :=0;
          sel :=False;
        End;
        Inc (item[0]^[0]^.size);
        Create_dir :=True;
      End
    Else
      {dir already exists, enter it}
      Begin
        curdir :=i;
        ofs :=1;
        Disp_list (l,True);
        Create_dir :=False;
      End;
  End;
End;

Procedure New_var (Var l : lst; v : pTIvar; disp : Boolean);
Var
  event,i,j,max : Word;
Begin
  With l Do
  Begin
    i :=2;
    max :=item[0]^[curdir]^.size;
    While (i<=max) And (item[curdir]^[i]^.name<v^.name) Do
      Inc (i);
    If (i<=max) And (item[curdir]^[i]^.name=v^.name) Then
      {overwrite}
      Begin
        With item[curdir]^[i]^ Do Begin
          FreeMem (data,dsize); Inc (_mfree,dsize); End;
        Dec (item[0]^[curdir]^.size);
      End
    Else
      {insert}
      Begin
        For j :=max DownTo i Do
          item[curdir]^[j+1] :=item[curdir]^[j];
        New (item[curdir]^[i]); Inc (_malloc,SizeOf (TIvar));
      End;
    item[curdir]^[i]^ :=v^;
    item[curdir]^[i]^.sel :=False;
    Inc (item[0]^[curdir]^.size);
    If disp Then
      Disp_list (l,False);
  End;
End;

Procedure Selection (Var l : lst);
Var
  i : Word;
  s : String[40];
Begin
  With l Do
  Begin
    Text (x-1,y2+1,'                                   ');
    s :=Number (3,sel_nb)+' file';
    If sel_nb>1 Then
      s :=s+'s';
    s :=s+' '+Number (6,sel_size)+' byte';
    If sel_size>1 Then
      s :=s+'s';
    Text (x-1,y2+1,s);
  End;
End;

Procedure Clean_list (Var l : lst);
Var
  i,j : Word;
Begin
  With l Do
    For i :=1 To item[0]^[0]^.size Do
      For j :=2 To item[0]^[i]^.size Do
        With item[i]^[j]^ Do Begin
          FreeMem (data,dsize); Inc (_mfree,dsize); End;
End;

Procedure Close_list (Var l : lst);
Var
  i,j : Word;
Begin
  With l Do
    For i :=item[0]^[0]^.size DownTo 0 Do
    Begin
      For j :=1 To item[0]^[i]^.size Do Begin
        Dispose (item[i]^[j]); Inc (_mfree,SizeOf (TIvar)); End;
      If i=0 Then Begin
        Dispose (l.item[0]^[0]); Inc (_mfree,SizeOf (TIvar)); End;
      Dispose (item[i]); Inc (_mfree,SizeOf (dir));
    End;
End;

End.