Unit Mouse;

{ Mouse interface - DOS/text mode }

Interface

Const
  double_delay : Word = 50;

Procedure Init_mouse_driver (verbose : Boolean);
Procedure Show_mouse;
Procedure Hide_mouse;
Procedure Get_mouse_XY (Var X,Y : Byte);
Function Get_mouse_clic : Byte;
Procedure Set_mouse_XY (X,Y : Byte);
Procedure Set_mouse_limit (X1,Y1,X2,Y2 : Byte);

Implementation

Uses Timer;

Const
  step : Byte = 0;
Var
  moved : Boolean;
  last_clic,last_mx,last_my,mx2,my2 : Byte;

Procedure Init_mouse_driver (verbose : Boolean);
Const
  _typ : Array [1..5] Of String[15] =
  ('bus','serial','InPort','PS/2','Hewlett Packard');
Var
  flag,nb : Word;
  major,minor,typ,irq : Byte;
Begin
  Asm
    xor  ax,ax
    int  33h
    mov  flag,ax
    mov  nb,bx

    mov  ax,24h
    int  33h
    mov  major,bh
    mov  minor,bl
    mov  typ,ch
    mov  irq,cl
  End;
  If verbose Then
  Begin
    Write ('Mouse driver detected : ');
    If (typ>=0) And (typ<=5) Then
      Write (_typ[typ],' type / ')
    Else
      Write ('unknown type / ');
    Write ('version ',major,'.',minor,' / IRQ ');
    If irq=0 Then
      WriteLn ('PS/2')
    Else
      WriteLn (irq);
  End;
End;

Procedure Show_mouse; Assembler;
Asm
  mov  ax,1
  int  33h
End;

Procedure Hide_mouse; Assembler;
Asm
  mov  ax,2
  int  33h
End;

Procedure Get_mouse_XY (Var X,Y : Byte);
Var
  a,b : Byte;
Begin
  Asm
    mov  ax,3
    int  33h
    shr  cx,3
    mov  a,cl
    shr  dx,3
    mov  b,dl
  End;
  X :=a;
  Y :=b;
  If (a<>mx2) Or (b<>my2) Then
    moved :=True
  Else
    moved :=False;
  mx2 :=a;
  my2 :=b;
End;

Function Get_mouse_clic : Byte;
Var
  c : Byte;
Begin
  Asm
    mov  ax,3
    int  33h
    mov  c,bl
  End;
  If count1=0 Then step :=0;
  If (c>0) And (count1=0) Then
  Begin
    count1 :=double_delay;
    last_clic :=c;
    last_mx :=mx2;
    last_my :=my2;
    step :=1;
  End;
  If (count1>0) Then
  Begin
    If (step=1) And (c=0) Then step :=2;
    If (step=3) Then
    Begin
      If (c=0) Then count1 :=0;
      c :=0;
    End;
    If (step=2) And (c=last_clic) And (last_mx=mx2) And (last_my=my2) Then
    Begin
      Inc (c,$80);
      step :=3;
    End;
  End;
  Get_mouse_clic :=c;
End;

Procedure Set_mouse_XY (X,Y : Byte); Assembler;
Asm
  mov  ax,4
  xor  ch,ch
  mov  cl,X
  shl  cx,3
  xor  dh,dh
  mov  dl,Y
  shl  dx,3
  int  33h
End;

Procedure Set_mouse_limit (X1,Y1,X2,Y2 : Byte); Assembler;
Asm
  mov  ax,7
  xor  ch,ch
  mov  cl,X1
  shl  cx,3
  xor  dh,dh
  mov  dl,X2
  shl  dx,3
  int  33h
  mov  ax,8
  mov  ch,ch
  mov  cl,Y1
  shl  cx,3
  xor  dh,dh
  mov  dl,Y2
  shl  dx,3
  int  33h
End;

End.
