Unit Txt;
{ 80*25 DOS/text mode I/O interface }

Interface

Const
  col_dialog_lim = #31;
  col_dialog_back = #31;
  col_status = #112;

Procedure Video_mode (mode : Byte);
Procedure Show_cursor;
Procedure Hide_cursor;
Procedure Set_cursor (x,y : Byte);
Procedure Clear (color : Byte);
Procedure Text (x,y : Byte; s : String);
Procedure TextC (x,y : Byte; s : Array Of Char);
Procedure Status (y : Byte; s : String);
Procedure Invert (x,y,n : Byte);
Procedure Attrib (x,y,attr : Byte);
Procedure Scroll_up (x1,y1,x2,y2 : Byte);
Procedure Scroll_dn (x1,y1,x2,y2 : Byte);
Function Number (n : Byte; x : LongInt) : String;
Function NumberHi (n : Byte; x : LongInt) : String;
Function UpCaseCh (ch : Char) : Char;
Function UpCase (s : String) : String;
Function LowCaseCh (ch : Char) : Char;
Function LowCase (s : String) : String;
Function Short (s : String) : String;
Function Extension (s : String) : String;
Function FileName (s : String) : String;
Function PascalStr (a : Array Of Char; n : Byte) : String;
Procedure Dialog (x1,y1,x2,y2 : Byte; title : String);
Procedure End_dialog;
Function Enter (title,invite : String; len : Byte) : String;

Implementation

Uses Keyb,Mouse;

Type
  _array = Array [0..0] Of Word;
Const
  dialog_max = 8;
  handle : Word = 0;
Var
  dialog_X1,dialog_X2,dialog_Y1,dialog_Y2 : Array [1..dialog_max] Of Byte;
  dialog_size : Word;
  dialog_window : Array [1..dialog_max] Of ^_array;

Procedure Video_mode (mode : Byte); Assembler;
Asm
  xor  ah,ah
  mov  al,mode
  int  10h
End;

Procedure Show_cursor; Assembler;
Asm
  mov  ah,1
  mov  cx,0D0Eh
  int  10h
End;

Procedure Hide_cursor; Assembler;
Asm
  mov  ah,1
  mov  cx,2000h
  int  10h
End;

Procedure Set_cursor (x,y : Byte); Assembler;
Asm
  mov  ah,2
  mov  bh,0
  mov  dl,x
  mov  dh,y
  int  10h
End;

Procedure Clear (color : Byte); Assembler;
Asm
  mov  ax,0b800h
  mov  es,ax
  xor  bx,bx
  mov  ch,color
  mov  cl,20h
  mov  dx,2000
  @re:
       mov  es:[bx],cx
       inc  bx
       inc  bx
       dec  dx
       jnz  @re
End;

Procedure Text (x,y : Byte; s : String);
Var
  a : Byte;
  ofs,w : Word;
Begin
  ofs :=y*160+x Shl 1;
  w :=Mem[$B800:ofs+1] Shl 8;
  a :=1;
  Repeat
    While s[a]=#0 Do
    Begin
      w :=Ord (s[a+1]) Shl 8;
      Inc (a,2);
    End;
{    If s[a]=#13 Then
      s[a] :=#32;}
    MemW[$B800:ofs] :=Ord (s[a])+w;
    Inc (ofs,2);
    Inc (a);
  Until a>Length (s);
End;

Procedure TextC (x,y : Byte; s : Array Of Char);
Var
  a : Byte;
  ofs,w : Word;
Begin
  ofs :=y*160+x Shl 1;
  w :=Mem[$B800:ofs+1] Shl 8;
  a :=1;
  While (s[a]<>#0) Do
  Begin
    Mem[$B800:ofs] :=Ord (s[a]);
    Inc (ofs,2);
    Inc (a);
  End;
End;

Procedure Status (y : Byte; s : String);
Begin
  Hide_mouse;
  Text (0,y,#0+col_status+'                                                                                ');
  Text (1,y,s);
  Show_mouse;
End;

Procedure Invert (x,y,n : Byte);
Var
  a : Byte;
  ofs : Word;
Begin
  ofs :=y*160+x*2+1;
  Hide_mouse;
  For a :=1 To n Do
  Begin
    Mem[$B800:ofs] :=Mem[$B800:ofs] Xor 80;
    Inc (ofs,2);
  End;
  Show_mouse;
End;

Procedure Attrib (x,y,attr : Byte);
Begin
  Mem[$B800:y*160+x Shl 1+1] :=attr;
End;

Procedure Scroll_up (x1,y1,x2,y2 : Byte); Assembler;
Asm
  push es
  mov  ax,0b800h
  mov  es,ax
  mov  ax,160
  mul  y1
  xor  bh,bh
  mov  bl,x1
  shl  bx,1
  add  bx,ax {bx=(x1,y1)}
  mov  ch,y2
  sub  ch,y1
  inc  ch    {ch=nb lines}
  mov  al,x2
  xor  ah,ah
  sub  al,x1
  inc  al    {ax=al=nb chars/line}
  @loopy:
       mov  cl,al
       @loopx:
            mov  dx,es:[bx]
            mov  es:[bx-160],dx
            inc  bx
            inc  bx
            dec  cl
            jnz  @loopx
       add  bx,160
       sub  bx,ax
       sub  bx,ax
       dec  ch
       jnz  @loopy
  pop  es
End;

Procedure Scroll_dn (x1,y1,x2,y2 : Byte); Assembler;
Asm
  push es
  mov  ax,0b800h
  mov  es,ax
  mov  ax,160
  mul  y2
  xor  bh,bh
  mov  bl,x1
  shl  bx,1
  add  bx,ax {bx=(x1,y2)}
  mov  ch,y2
  sub  ch,y1
  inc  ch    {ch=nb lines}
  mov  al,x2
  xor  ah,ah
  sub  al,x1
  inc  al    {ax=al=nb chars/line}
  @loopy:
       mov  cl,al
       @loopx:
            mov  dx,es:[bx-160]
            mov  es:[bx],dx
            inc  bx
            inc  bx
            dec  cl
            jnz  @loopx
       sub  bx,160
       sub  bx,ax
       sub  bx,ax
       dec  ch
       jnz  @loopy
  pop  es
End;

Function Number (n : Byte; x : LongInt) : String;
Var
  a,b : Byte;
  s : String[16];
Begin
  s :='                ';
  s[0] :=Chr (n);
  a :=n;
  Repeat
    s[a] :=Chr (48+(x Mod 10));
    x :=x Div 10;
    Dec (a);
  Until (a=0) Or (x=0);
  Number :=s;
End;

Function NumberHi (n : Byte; x : LongInt) : String;
Var
  a,b : Byte;
  s,res : String[20];
Begin
  s :='                    ';
  s[0] :=Chr (n);
  a :=0;
  Repeat
    Inc (a);
    s[a] :=Chr (48+(x Mod 10));
    x :=x Div 10;
  Until (a=n) Or (x=0);
  b :=0;
  Repeat
    Inc (b);
    res[b] :=s[a];
    Dec (a);
    If (a>0) And (a Mod 3=0) Then
    Begin
      Inc (b);
      res[b] :=',';
    End;
  Until (a=0);
  res[0] :=Chr (b);
  NumberHi :=res;
End;

Function UpCaseCh (ch : Char) : Char;
Var
  b : Byte;
Begin
  b :=Ord (ch);
  If (b>=97) And (b<=122) Then Dec (b,32);
  UpCaseCh :=Chr (b);
End;

Function UpCase (s : String) : String;
Var
  a,b : Byte;
Begin
  UpCase[0] :=s[0];
  For a :=1 To Length (s) Do
  Begin
    b :=Ord (s[a]);
    If (b>=97) And (b<=122) Then Dec (b,32);
    UpCase[a]:=Chr (b);
  End;
End;

Function Short (s : String) : String;
Var
  a : Byte;
Begin
  Short :=s;
  a :=Length (s);
  While (a>0) And (s[a]=' ') Do
    Dec (a);
  Short[0] :=Chr (a);
End;

Function LowCaseCh (ch : Char) : Char;
Var
  b : Byte;
Begin
  b :=Ord (ch);
  If (b>=65) And (b<=90) Then Inc (b,32);
  LowCaseCh :=Chr (b);
End;

Function LowCase (s : String) : String;
Var
  a,b : Byte;
Begin
  LowCase[0] :=s[0];
  For a :=1 To Length (s) Do
  Begin
    b :=Ord (s[a]);
    If (b>=65) And (b<=90) Then Inc (b,32);
    LowCase[a]:=Chr (b);
  End;
End;

Function Extension (s : String) : String;
Var
  a,b : Byte;
  r : String;
Begin
  r :='';
  a :=Length (s);
  While (a>0) And (s[a]<>'.') Do
    Dec (a);
  If a>0 Then
  Begin
    For b :=a+1 To Length (s) Do
      r[b-a] :=s[b];
    r[0] :=Chr (Length (s)-a);
  End;
  Extension :=r;
End;

Function FileName (s : String) : String;
Var
  a : Byte;
Begin
  a :=1;
  While (a<=Length (s)) And (s[a]<>'.') Do
    Inc (a);
  s[0] :=Chr (a-1);
  FileName :=s;
End;

Function PascalStr (a : Array Of Char; n : Byte) : String;
Var
  c : Byte;
  s : String;
Begin
  c :=0;
  While (c<n) And (a[c]<>#0) Do
  Begin
    Inc (c);
    s[c] :=a[c-1];
  End;
  s[0] :=Chr (c);
  PascalStr :=s;
End;

Procedure Dialog (x1,y1,x2,y2 : Byte; title : String);
Const
  _void : String = '                                                                                ';
  _lim  : String = '';
Var
  a,i,j : Byte;
  w,ofs : Word;
Begin
  Inc (handle);
  dialog_X1[handle] :=x1-1;
  dialog_X2[handle] :=x2+3;
  dialog_Y1[handle] :=y1-1;
  dialog_Y2[handle] :=y2+2;
  w :=(dialog_X2[handle]-dialog_X1[handle]+1)*(dialog_Y2[handle]-dialog_Y1[handle]+1) Shl 1;
  GetMem (dialog_window[handle],w);
  w :=0;
  ofs :=dialog_Y1[handle]*160+dialog_X1[handle] Shl 1;
  a :=160-(dialog_X2[handle]-dialog_X1[handle]+1) Shl 1;
  Hide_mouse;
  For i :=dialog_Y1[handle] To dialog_Y2[handle] Do
  Begin
    For j :=dialog_X1[handle] To dialog_X2[handle] Do
    Begin
      Dialog_window[handle]^[w] :=MemW[$B800:ofs];
      Inc (ofs,2);
      Inc (w);
    End;
    Inc (ofs,a);
  End;
  i :=x2-x1+1;
  _void[0] :=Chr (i);
  _lim[0] :=Chr (i);
  i :=x1+(i-Length (title)) Shr 1;
  Text (x1-1,y1-1,#0+col_dialog_lim+''+_lim+'');
  Text (i,y1-1,title);
  For i :=y1 To y2 Do
  Begin
    Text (x1-1,i,#0+col_dialog_lim+''+#0+col_dialog_back+_void+#0+col_dialog_lim+'');
    Attrib (x2+2,i,8);
    Attrib (x2+3,i,8);
  End;
  Text (x1-1,y2+1,#0+col_dialog_lim+''+_lim+'');
  Attrib (x2+2,y2+1,8);
  Attrib (x2+3,y2+1,8);
  For i :=x1+1 To x2+3 Do
    Attrib (i,y2+2,8);
  Set_mouse_limit (x1,y1,x2,y2);
  Show_mouse;
End;

Procedure End_dialog;
Var
  a,i,j : Byte;
  w,ofs : Word;
Begin
  w :=0;
  ofs :=dialog_Y1[handle]*160+dialog_X1[handle] Shl 1;
  a :=160-(dialog_X2[handle]-dialog_X1[handle]+1) Shl 1;
  Hide_mouse;
  For i :=dialog_Y1[handle] To dialog_Y2[handle] Do
  Begin
    For j :=dialog_X1[handle] To dialog_X2[handle] Do
    Begin
      MemW[$B800:ofs] :=Dialog_window[handle]^[w];
      Inc (ofs,2);
      Inc (w);
    End;
    Inc (ofs,a);
  End;
  w :=(dialog_X2[handle]-dialog_X1[handle]+1)*(dialog_Y2[handle]-dialog_Y1[handle]+1) Shl 1;
  FreeMem (dialog_window[handle],w);
  Dec (handle);
  Set_mouse_limit (0,0,79,24);
  Show_mouse;
End;

Function Enter (title,invite : String; len : Byte) : String;
Const
  void : String[20] = '                    ';
Var
  ch : Char;
  x,n : Byte;
  l : Word;
  res : String;
Begin
  Inc (len);
  l :=Length (invite)+len;
  If l<Length (title) Then
    l :=Length (title);
  Inc (l,2);
  Hide_mouse;
  Dialog (40-l Shr 1,11,40+l Shr 1,13,title);
  void[0] :=Chr (len);
  Text (40-(Length (invite)+len) Shr 1,12,invite+#0#15+void);
  x :=40-(Length (invite)+len) Shr 1+Length (invite);
  Set_cursor (x,12);
  Show_cursor;

  Dec (len);
  n :=0;
  Repeat
    Repeat
    Until KeyPressed;
    ch :=ReadKey;
    Case ch Of
      #32..#122: If n<len Then
                 Begin
                   Text (x,12,ch);
                   Inc (n);
                   res[n] :=ch;
                   Inc (x);
                   Set_cursor (x,12);
                 End;
      #8: If n>0 Then
          Begin
            Dec (n);
            Dec (x);
            Text (x,12,' ');
            Set_cursor (x,12);
          End;
    End;
  Until (ch=#13) Or (ch=#27);

  If ch=#27 Then
    n :=0;
  res[0] :=Chr (n);
  Enter :=res;
  End_dialog;
  Hide_cursor;
  Show_mouse;
End;

End.